import os
from math import sqrt
#from shallow_water_h import *
from shallow_water_domain_suggestion1 import *
from Numeric import zeros, Float
from analytic_dam_sudi import AnalyticDam

h0=5.0
h1=10.0

analytical_sol=AnalyticDam(h0,h1)

"""
def newLinePlot(title='Simple Plot'):
    import Gnuplot
    gg=Gnuplot.Gnuplot(persist=0)
    gg.title(title)
    gg('set data style linespoints')
    gg.xlabel('x')
    gg.ylabel('y')
    return gg

def linePlot(gg, x1, y1, x2, y2):
    import Gnuplot
    plot1=Gnuplot.PlotItems.Data(x1.flat, y1.flat, with="linespoints")
    plot2=Gnuplot.PlotItems.Data(x2.flat, y2.flat, with="lines 3")
    gg.plot(plot1, plot2)
"""


print "TEST 1D-SOLUTION I"

L=2000.0
N=400

cell_len=L/N

points=zeros(N+1, Float)
for i in range(N+1):
    points[i]=i*cell_len

domain=Domain(points)

domain.order = 1
domain.set_timestepping_method('euler')
domain.cfl = 1.0
#domain.limiter = "vanalbada"



def height(x):
    y=zeros(len(x), Float)
    for i in range (len(x)):
        if x[i]<=L/4.0:
            y[i]=0.0 #h0
        elif x[i]<=3*L/4.0:
            y[i]=h1
        else:
            y[i]=h0
    return y

domain.set_quantity('stage',height)
print "domain order", domain.order

domain.set_boundary({'exterior':Reflective_boundary(domain)})

X=domain.vertices
C=domain.centroids
#plot1x=newLinePlot("Height")
#plot2x=newLinePlot("Momentum")

import time
yieldstep=finaltime=0.5
t0=time.time()

"""
for i in range(10):
    L=2000.0
    N=800
    cell_len=L/N
    points=zeros(N+1, Float)
    for i in range(N+1):
        points[i]=i*cell_len
    domain=Domain(points)
    domain.order = 2
    domain.set_timestepping_method('rk2')
    domain.cfl = 1.0
    domain.limiter = "vanleer"
    domain.set_quantity('stage',height)
    domain.set_boundary({'exterior':Reflective_boundary(domain)})
    #print "integral", domain.quantities['stage'].get_integral()
    for t in domain.evolve(yieldstep=yieldstep, finaltime=finaltime):
        domain.write_time()
    #print "integral", domain.quantities['stage'].get_integral()
    #print '==================================================================='
print 'The average time is %.2f seconds'%((time.time()-t0)/10.0)
"""
while finaltime < 20.1:
    for t in domain.evolve(yieldstep=yieldstep, finaltime=finaltime):
        domain.write_time()
    if t>0.0:
        N = float(N)
        StageC = domain.quantities['stage'].centroid_values
        XmomC = domain.quantities['xmomentum'].centroid_values
        VelC = domain.quantities['velocity'].centroid_values
        C = domain.centroids
        hC, uhC, uC = analytical_sol(C,domain.time)
        h_error = cell_len*sum(abs(hC-StageC))
        uh_error = cell_len*sum(abs(uhC-XmomC))
        u_error = cell_len*sum(abs(uC-VelC))
        print "h_error %.10f" %(h_error)
        print "uh_error %.10f"%(uh_error)
        print "u_error %.10f" %(u_error)
        print 'That took %.2f seconds' %(time.time()-t0)
        X = domain.vertices
        StageQ = domain.quantities['stage'].vertex_values
        XmomQ = domain.quantities['xmomentum'].vertex_values
        VelQ = domain.quantities['velocity'].vertex_values

        h, uh, u = analytical_sol(X.flat, domain.time)
        #linePlot(plot1x, X, HeightQ, X, h)
        #linePlot(plot2x, X, MomentumQ, X, uh)
        #print "press return"
        #pass
   
        from pylab import plot,title,xlabel,ylabel,legend,savefig,show,hold,subplot
        hold(False)
           
        plot1 = subplot(311)
        plot(X,h,X,StageQ)
        plot1.set_ylim([-1,11])
        plot1.set_xlim([-100.0,2000.0])
        #xlabel('Position')
        ylabel('Stage')
        #legend(('Analytical Solution', 'Numerical Solution'),
        #   'lower right', shadow=False)
        
        plot2 = subplot(312)
        plot(X,uh,X,XmomQ)
        #plot2.set_ylim([-5,35])
        plot2.set_xlim([-100.0,2000.0])
        #legend(('Analytical Solution', 'Numerical Solution'),
        #        'lower right', shadow=False)
        #xlabel('Position')
        ylabel('Momentum')

        plot3 = subplot(313)
        plot(X,u,X,VelQ)
        #plot2.set_ylim([-5,35])
        plot3.set_xlim([-100.0,2000.0])
        legend(('Analytical Solution', 'Numerical Solution'),
            'lower right', shadow=False)
        xlabel('Position')
        ylabel('Velocity')
    
        #file = "dam_h_"
        #file += str(number_of_cells[i])
        #file += ".eps"
        #savefig(file)
        #show()
        file = "dam"
        file += str(finaltime)
        file += ".png"
        savefig(file)
    finaltime = finaltime + 0.5
    print "The domain.limiter is", domain.limiter
    print 'That took %.2f seconds'%(time.time()-t0)
    print '============================================================================='

