import os
from math import sqrt, sin, cos, pi, exp
from shallow_water_domain_suggestion3 import *
from Numeric import zeros, Float

print "TEST 1D-SOLUTION I"

L=2.0
N=200
cell_len=L/N
points=zeros(N+1, Float)
for i in range(N+1):
    points[i]=i*cell_len

domain=Domain(points)
domain.order = 2
domain.set_timestepping_method('rk2')
domain.cfl = 1.0
domain.limiter = "minmod"

def stage_perturb(x):
    y=zeros(len(x), Float)
    for i in range(len(x)):
        if 1.1 <= x[i] <=1.2:
            y[i]=1.001
        else:
            y[i]=1.0
    return y

def elevation_parabol(x):
    y=zeros(len(x), Float)
    for i in range(len(x)):
        if 1.4 <= x[i] <= 1.6:
            y[i] = 0.25*(1.0+cos(10*pi*(x[i]-0.5)))
        else:
            y[i] = 0.0
    return y

domain.set_quantity('stage',stage_perturb)
domain.set_quantity('elevation', elevation_parabol)
domain.set_boundary({'exterior':Reflective_boundary(domain)})
#X=domain.vertices
#C=domain.centroids

import time
yieldstep=finaltime=0.25/100
t0=time.time()
i=0
print "integral", domain.quantities['stage'].get_integral()
while finaltime < 0.25001/100:
    for t in domain.evolve(yieldstep=yieldstep, finaltime=finaltime):
        domain.write_time() 
        X = domain.vertices
        StageQ = domain.quantities['stage'].vertex_values
        XmomQ = domain.quantities['xmomentum'].vertex_values
        VelQ = domain.quantities['velocity'].vertex_values
        ElevQ = domain.quantities['elevation'].vertex_values

        from pylab import plot,title,xlabel,ylabel,legend,savefig,show,hold,subplot
        hold(False)
            
        plot1 = subplot(311)
        plot(X,StageQ,X,ElevQ) #(X,ElevQ,X,StageQ)
        plot1.set_ylim([-0.1,1.1])
        #plot1.set_ylim([0.9999,1.001])
        legend(('Stage','Bed Elevation'),'center left', shadow=False)
        ylabel('Stage')
            
        plot2 = subplot(312)
        plot(X,XmomQ)
        ylabel('Momentum')
    
        plot3 = subplot(313)
        plot(X,VelQ)
        #legend(('Numerical Solution',' '),'lower right', shadow=False)
        xlabel('Position')
        ylabel('Velocity')
    
        #print "The domain.limiter is", domain.limiter
        #print "domain order", domain.order
        #print 'That took %.2f seconds' %(time.time()-t0)
        #print '============================================================================='
 
        #file = "perturb"
        #file += str(finaltime)
        #file += ".png"
        #show()
        #savefig(file)
        
        filename = "%s%04i%s" %("perturbation", i, ".eps")
        savefig(filename)

        finaltime = finaltime + 0.25/100
        i=i+1

