import os
from math import sqrt, sin, cos, pi, exp
from shallow_water_domain_suggestion3 import *
from Numeric import zeros, Float

print "TEST 1"

L=2.0
N=200
cell_len=L/N
points=zeros(N+1, Float)
for i in range(N+1):
    points[i]=i*cell_len

domain=Domain(points)
domain.order = 1
domain.set_timestepping_method('euler')
domain.cfl = 1.0

def stage_perturb(x):
    y=zeros(len(x), Float)
    for i in range(len(x)):
        if 1.1 <= x[i] <=1.2:
            y[i]=1.001
        else:
            y[i]=1.0
    return y

def elevation_parabol(x):
    y=zeros(len(x), Float)
    for i in range(len(x)):
        if 1.4 <= x[i] <= 1.6:
            y[i] = 0.25*(1.0+cos(10*pi*(x[i]-0.5)))
        else:
            y[i] = 0.0
    return y

domain.set_quantity('stage',stage_perturb)
domain.set_quantity('elevation', elevation_parabol)
domain.set_boundary({'exterior':Reflective_boundary(domain)})
X=domain.vertices
C=domain.centroids

import time
yieldstep=finaltime=0.2
t0=time.time()
print "integral", domain.quantities['stage'].get_integral()
for t in domain.evolve(yieldstep=yieldstep, finaltime=finaltime):
    domain.write_time() 
StageQ = domain.quantities['stage'].vertex_values
XmomQ = domain.quantities['xmomentum'].vertex_values
VelQ = domain.quantities['velocity'].vertex_values
ElevQ = domain.quantities['elevation'].vertex_values

StageC = domain.quantities['stage'].centroid_values
XmomC = domain.quantities['xmomentum'].centroid_values
VelC = domain.quantities['velocity'].centroid_values
ElevC = domain.quantities['elevation'].centroid_values







print "TEST 2"

L=2.0
N=200
cell_len=L/N
points=zeros(N+1, Float)
for i in range(N+1):
    points[i]=i*cell_len

domain=Domain(points)
domain.order = 2
domain.set_timestepping_method('rk2')
domain.cfl = 1.0
domain.limiter = "minmod"

def stage_perturb(x):
    y=zeros(len(x), Float)
    for i in range(len(x)):
        if 1.1 <= x[i] <=1.2:
            y[i]=1.001
        else:
            y[i]=1.0
    return y

def elevation_parabol(x):
    y=zeros(len(x), Float)
    for i in range(len(x)):
        if 1.4 <= x[i] <= 1.6:
            y[i] = 0.25*(1.0+cos(10*pi*(x[i]-0.5)))
        else:
            y[i] = 0.0
    return y

domain.set_quantity('stage',stage_perturb)
domain.set_quantity('elevation', elevation_parabol)
domain.set_boundary({'exterior':Reflective_boundary(domain)})
XX=domain.vertices
CC=domain.centroids

import time
yieldstep=finaltime=0.2
t0=time.time()
print "integral", domain.quantities['stage'].get_integral()
for t in domain.evolve(yieldstep=yieldstep, finaltime=finaltime):
    domain.write_time() 
StageQQ = domain.quantities['stage'].vertex_values
XmomQQ = domain.quantities['xmomentum'].vertex_values
VelQQ = domain.quantities['velocity'].vertex_values
ElevQQ = domain.quantities['elevation'].vertex_values

StageCC = domain.quantities['stage'].centroid_values
XmomCC = domain.quantities['xmomentum'].centroid_values
VelCC = domain.quantities['velocity'].centroid_values
ElevCC = domain.quantities['elevation'].centroid_values




print "REFERENCE SOLUTION"

L=2.0
N=3200
cell_len=L/N
points=zeros(N+1, Float)
for i in range(N+1):
    points[i]=i*cell_len

domain=Domain(points)
domain.order = 2
domain.set_timestepping_method('rk2')
domain.cfl = 1.0
domain.limiter = "minmod"

def stage_perturb(x):
    y=zeros(len(x), Float)
    for i in range(len(x)):
        if 1.1 <= x[i] <=1.2:
            y[i]=1.001
        else:
            y[i]=1.0
    return y

def elevation_parabol(x):
    y=zeros(len(x), Float)
    for i in range(len(x)):
        if 1.4 <= x[i] <= 1.6:
            y[i] = 0.25*(1.0+cos(10*pi*(x[i]-0.5)))
        else:
            y[i] = 0.0
    return y

domain.set_quantity('stage',stage_perturb)
domain.set_quantity('elevation', elevation_parabol)
domain.set_boundary({'exterior':Reflective_boundary(domain)})
#X=domain.vertices
#C=domain.centroids

import time
yieldstep=finaltime=0.2
t0=time.time()
print "integral", domain.quantities['stage'].get_integral()
for t in domain.evolve(yieldstep=yieldstep, finaltime=finaltime):
    domain.write_time() 
XXX = domain.vertices
StageQQQ = domain.quantities['stage'].vertex_values
XmomQQQ = domain.quantities['xmomentum'].vertex_values
VelQQQ = domain.quantities['velocity'].vertex_values
ElevQQQ = domain.quantities['elevation'].vertex_values

from pylab import plot,title,xlabel,ylabel,legend,savefig,show,hold,subplot
hold(False)
"""  
plot1 = subplot(311)
plot(X,StageQ,'k:', XX,StageQQ,'k,', XXX,StageQQQ,'k-')
plot1.set_ylim([0.9999,1.0006])
ylabel('Stage')
"""

"""
plot1 = subplot(211)
plot(C,XmomC,'k:', CC,XmomCC,'k,', XXX,XmomQQQ,'k-')
ylabel('Momentum')

plot2 = subplot(212)
plot(C,VelC,'k:', CC,VelCC,'k,', XXX,VelQQQ,'k-')
legend(('first order scheme','second order scheme','reference solution'),'lower right', shadow=False)
xlabel('Position')
ylabel('Velocity')
   
print "The domain.limiter is", domain.limiter
print "domain order", domain.order
print 'That took %.2f seconds' %(time.time()-t0)
print '============================================================================='
#file = "perturb"
#file += str(finaltime)
#file += ".png"
#show()
#savefig(file)
"""


plot(C,StageC,'k:', CC,StageCC,'k.', XXX,StageQQQ,'k-')
xlabel('Position')
ylabel('Stage')
legend(('first order','second order','reference'),'upper center', shadow=False)


