import os
from math import sqrt, sin, cos, pi, exp
from shallow_water_domain_suggestion3 import *
from Numeric import zeros, Float

print "TEST USING 3 CELLS"
L=1500.0
N=3
cell_len=L/N

points=zeros(N+1, Float)
for i in range(N+1):
    points[i]=i*cell_len

domain=Domain(points)
domain.order = 1
domain.set_timestepping_method('euler')
domain.cfl = 1.0
domain.limiter = "minmod"
print 'THE DOMAIN LIMITER is', domain.limiter

def stage_3cells(x):
    y=zeros(len(x), Float)
    for i in range(len(x)):
        if x[i]<= 500.0:
            y[i] = 1.5 #y[i]=4.0
        elif 500.0 < x[i] < 1000.0:
            y[i] = 1.8
        else:
            y[i] = 3.75 #y[i] = x[i]/150.0
    return y

def elevation_3cells(x):
    y=zeros(len(x), Float)
    for i in range(len(x)):
        if x[i]<= 500.0:
            y[i] = 0.5 #y[i]=4.0
        elif 500.0 < x[i] < 1000.0:
            y[i] = 1.8
        else:
            y[i] = 3.75 #y[i] = x[i]/150.0
    return y


domain.set_quantity('stage',stage_3cells)
domain.set_quantity('elevation',elevation_3cells)
domain.set_boundary({'exterior':Reflective_boundary(domain)})

X=domain.vertices
C=domain.centroids

import time
t0=time.time()
yieldstep=10.0 #30.0
finaltime=10.0 #20.0
print "integral", domain.quantities['height'].get_integral()
for t in domain.evolve(yieldstep=yieldstep, finaltime=finaltime):
    domain.write_time()
    print "integral", domain.quantities['height'].get_integral()
    if t>=0.0:
        StageQ=domain.quantities['stage'].vertex_values
        MomentumQ=domain.quantities['xmomentum'].vertex_values
        ElevationQ=domain.quantities['elevation'].vertex_values

        from pylab import clf,plot,title,xlabel,ylabel,legend,savefig,show,hold,subplot,ion
        hold(False)

        plot1 = subplot(211)
        plot(X,StageQ, X,ElevationQ)  #plot(X,StageQ, X,h, X,ElevationQ)   #(X,ElevationQ,X,StageQ, X,h)
        plot1.set_ylim([0.0,4.0]) #([9.999,10.006]) #([9.9999,10.0006]) #([-1.0,11.0])
        xlabel('Position')
        ylabel('Stage')
        legend( ('Numerical Solution', 'Bed Elevation'), 'upper right', shadow=False)
        #legend(('Analytical Solution', 'Numerical Solution'),
        #   'lower right', shadow=False)

        plot2 = subplot(212)
        plot(X,MomentumQ)   #plot(X,MomentumQ, X,uh)
        #plot2.set_ylim([-5.0,30.0])
        legend( ('Numerical Solution', 'for momentum'), 'upper right', shadow=False)
    
        xlabel('Position')
        ylabel('Xmomentum')

        '''
        plot3 = subplot(313)
        plot(X,VelocityQ) #plot(X,MomentumQ, X,uh)
        #plot2.set_ylim([-0.01,0.01])
        legend( ('Numerical Solution', 'for velocity'), 'upper right', shadow=False)
        xlabel('Position')
        ylabel('Velocity')
        '''
        
        #file = "dam_h_"
        #file += str(number_of_cells[i])
        #file += ".eps"
        #savefig(file)
        show()
        
print 'That took %.2f seconds'%(time.time()-t0)
raw_input("Press return key")

