#ifndef ANUGAVIS_ERROR_H
#define ANUGAVIS_ERROR_H

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#ifdef HAVE_GL_GL_H
#  include <GL/gl.h>
#elif HAVE_OPENGL_GL_H
#  include <OpenGL/gl.h>
#endif

/* Set the error message with a printf-style format string.
 */
extern void AnugaVis_SetError(const char *format, ...);
/* Report a SDL error.
 */
extern void AnugaVis_SDLError(void);
/* Report a NetCDF error.
 */
extern void AnugaVis_NetCDFError(int ncerr);
/* Report an OpenGL error.
 */
extern void AnugaVis_OpenGLError(GLenum errorCode);

/* Get detailed error information. The returned string should not be
 * freed by the caller.
 */
extern char* AnugaVis_GetError(void);

#endif
