#ifndef HEIGHT_QUANTITY_H
#define HEIGHT_QUANTITY_H

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#if HAVE_STDINT_H
#  include <stdint.h>
#endif
#ifdef HAVE_GL_GL_H
#  include <GL/gl.h>
#elif HAVE_OPENGL_GL_H
#  include <OpenGL/gl.h>
#endif
struct height_quantity_simple {
  char *name;
  uint8_t frames;
  double offset;
  double scale;
  GLfloat red;
  GLfloat green;
  GLfloat blue;
  GLuint displayLists;
  struct height_quantity_simple *next;
};

/* Define (or redefine if already defined a simple height quantity with the 
 * given offset, scale, and color. Returns 0 on success, -1 on error.
 */
extern int AnugaVis_DefineHeightQuantity(const char *name,
					 double offset, double scale,
					 GLfloat red, GLfloat green,
					 GLfloat blue);
/* Draw a height quantity.
 */
extern void AnugaVis_DrawHeightQuantity(struct height_quantity_simple *height);
/* Undefine a given simple height quantity.
 */
extern void AnugaVis_UndefineHeightQuantity(const char *name);

#endif
