#include <netcdf.h>
#include "error.h"

int nc_inq_dimlen_by_name(int ncid, const char *name, size_t *size){
  int status;
  int dimid;
  if(((status = nc_inq_dimid(ncid, name, &dimid)) != NC_NOERR) ||
     ((status = nc_inq_dimlen(ncid, dimid, size)) != NC_NOERR))
    AnugaVis_NetCDFError(status);
  return status;
}

int nc_get_var_float_by_name(int ncid, const char *name, float *fp){
  int status;
  int varid;
  if(((status = nc_inq_varid(ncid, name, &varid)) != NC_NOERR) ||
     ((status = nc_get_var_float(ncid, varid, fp)) != NC_NOERR))
    AnugaVis_NetCDFError(status);
  return status;
}

int nc_get_var_int_by_name(int ncid, const char *name, int *ip){
  int status;
  int varid;
  if(((status = nc_inq_varid(ncid, name, &varid)) != NC_NOERR) ||
     ((status = nc_get_var_int(ncid, varid, ip)) != NC_NOERR))
    AnugaVis_NetCDFError(status);
  return status;
}
