#ifndef VECTOR_HH
#define VECTOR_HH

class Vector{
public:
  Vector(void): x(0.0), y(0.0), z(0.0) {}
  Vector(float x, float y, float z): x(x), y(y), z(z) {}
  Vector &operator += (const Vector &other);
  Vector operator + (const Vector &other) const;
  Vector &operator -= (const Vector &other);
  Vector operator - (const Vector &other) const;
  Vector cross(const Vector &other) const;
  float dot(const Vector &other) const;
  float magnitude(void) const;
  Vector scale(float amount) const;
  float x;
  float y;
  float z;
};

#endif
