# -*- coding: cp1252 -*-
"""Common filenames and locations for topographic data, meshes and outputs.
"""

from os import sep, environ, getenv, getcwd
from os.path import expanduser
import sys
from time import localtime, strftime, gmtime
from anuga.utilities.polygon import read_polygon, plot_polygons, \
                                    polygon_area, is_inside_polygon

###############################
# Domain definitions
###############################

# bounding polygon for study area
bounding_polygon = read_polygon('extent.csv')

print 'Area of bounding polygon', polygon_area(bounding_polygon)/1000000.0

###############################
# Interior region definitions
###############################

# interior polygons
poly_cairns = read_polygon('cairns.csv')
poly_island0 = read_polygon('islands.csv')
poly_island1 = read_polygon('islands1.csv')
poly_island2 = read_polygon('islands2.csv')
poly_island3 = read_polygon('islands3.csv')
poly_shallow = read_polygon('shallow.csv')

#plot_polygons([bounding_polygon,poly_cairns,poly_island0,poly_island1,\
#               poly_island2,poly_island3,poly_shallow],\
#              'boundingpoly',verbose=False)

###################################################################
# Clipping regions for export to asc and regions for clipping data
###################################################################

# exporting asc grid
eastingmin = 363000
eastingmax = 418000
northingmin = 8026600
northingmax = 8145700


slide_origin = [451871, 8128376] # move onto the continental shelf, depth = 500
slide_depth = 500.

gauge_filename = 'gauges.csv'
