import project_truescale, os
import sys
import time
from anuga.shallow_water.data_manager import convert_dem_from_ascii2netcdf, dem2pts
from anuga.shallow_water.data_manager import sww2dem
from anuga.geospatial_data.geospatial_data import *
from os import sep

res_dir1 = '20080725_051221_run_octuple_contour_polygons_lfountai'
res_dir2 = '20080715_023223_run_quadruple_contour_polygons_lfountai'
res_dir3 = '20080708_064841_run_double_contour_polygons_lfountai'
res_dir4 = '20080708_064714_run_original_contour_polygons_lfountai'
res_dir5 = '20080708_064815_run_half_contour_polygons_lfountai'
res_dir6 = '20080714_231759_run_quarter_contour_polygons_lfountai'
res_dir7 = '20080714_234934_run_eighth_contour_polygons_lfountai'
res_dir8 = '20080714_235634_run_sixteenth_contour_polygons_lfountai'
res_dir9 = '20080715_015727_run_1-32_contour_polygons_lfountai'
res_dir10 = '20080721_015521_run_1-64_contour_polygons_lfountai'
res_dirs = [res_dir1, #res_dir2, res_dir3, res_dir4, res_dir5, res_dir6, res_dir7, res_dir8,res_dir9,
            res_dir10]
#timesteps = [200, 250, 300, 350, 400, 450]
timesteps = [327] #this is time of maximum inundation


for res_dir in res_dirs:
    
    for timestep in timesteps:
                
        directory = project_truescale.output_dir+res_dir+sep
        name = directory+'okushiri_truescale'

        is_parallel = False
        #is_parallel = True

        if is_parallel == True: nodes = 10
        print 'output directory:', directory

        area = ['Deep', 'Mid', 'Shallow']
            
        for which_area in area:
            if which_area == 'Deep':
                cellsize = 50
                easting_min = project_truescale.xminDeep
                easting_max = project_truescale.xmaxDeep
                northing_min = project_truescale.yminDeep
                northing_max = project_truescale.ymaxDeep

            if which_area == 'Mid':
                cellsize = 25
                easting_min = project_truescale.xminMid
                easting_max = project_truescale.xmaxMid
                northing_min = project_truescale.yminMid
                northing_max = project_truescale.ymaxMid

            if which_area == 'Shallow':
                cellsize = 10
                easting_min = project_truescale.xminShallow
                easting_max = project_truescale.xmaxShallow
                northing_min = project_truescale.yminShallow
                northing_max = project_truescale.ymaxShallow

    ##    which_area='all'
    ##    easting_min=0
    ##    easting_max=2179.2
    ##    northing_min=0
    ##    northing_max=1360.8
    ##    cellsize=10
        
           
            var = [2]
                
            for which_var in var:
                if which_var == 0:  # Stage
                    outname = directory + which_area + '_stage_' + str(timestep)
                    quantityname = 'stage'

                if which_var == 1:  # Absolute Momentum
                    outname = directory + which_area + '_momentum_' + str(timestep)
                    quantityname = '(xmomentum**2 + ymomentum**2)**0.5'  

                if which_var == 2:  # Depth
                    outname = directory + which_area + '_depth_' + str(timestep)
                    quantityname = 'stage-elevation'  

                if which_var == 3:  # Speed
                    outname = directory + which_area + '_speed_' + str(timestep)
                    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed

                if which_var == 4:  # Elevation
                    outname = directory + which_area + '_elevation_' + str(timestep)
                    quantityname = 'elevation'  

    ##            if is_parallel == True:
    ##            #    print 'is_parallel',is_parallel
    ##                for i in range(0,nodes):
    ##                    namei = name + '_P%d_%d' %(i,nodes)
    ##                    outnamei = outname + '_P%d_%d' %(i,nodes)
    ##                    print 'start sww2dem for sww file %d' %(i)
    ##                    sww2dem(namei, basename_out = outnamei,
    ##                                quantity = quantityname,
    ##                                timestep = timestep,
    ##                                cellsize = cellsize,      
    ##                                easting_min = project_grad.e_min_area,
    ##                                easting_max = project_grad.e_max_area,
    ##                                northing_min = project_grad.n_min_area,
    ##                                northing_max = project_grad.n_max_area,        
    ##                                reduction = max, 
    ##                                verbose = True,
    ##                                format = 'asc')
    ##            else:

                
                print 'start sww2dem', which_area
                sww2dem(name, basename_out = outname,
                            quantity = quantityname,
                            timestep = timestep,
                            cellsize = cellsize,      
                            easting_min = easting_min,
                            easting_max = easting_max,
                            northing_min = northing_min,
                            northing_max = northing_max,        
                            reduction = max, 
                            verbose = True,
                            format = 'ers')


##convert_dem_from_ascii2netcdf(outname, use_cache=True, verbose=True)
##dem2pts(outname, use_cache=True, verbose=True)
##G = Geospatial_data(file_name = outname + '.pts')
##G.export_points_file('test' + '.txt') 
