"""
Generate time series of nominated "gauges" read from project.gauge_filename. This 
is done by first running sww2csv_gauges on two different directories to make 
'csv' files. Then running csv2timeseries_graphs detailing the two directories 
containing the csv file and produces one set of graphs in the 'output_dir' containing
the details at the gauges for both these sww files.

Note, this script will only work if pylab is installed on the platform

"""

from os import sep
from anuga.abstract_2d_finite_volumes.util import sww2csv_gauges,csv2timeseries_graphs

import project_truescale

#timestamp='20080617_001810_run_leharne'
#timestamp='20080617_041810_run_original_no_int_polygons_lfountai'
#timestamp='20080617_040837_run_half_lfountai'
#timestamp='20080617_041356_run_double_lfountai'
#timestamp='20080708_064714_run_original_contour_polygons_lfountai'
#timestamp='20080708_064815_run_half_contour_polygons_lfountai'
#timestamp='20080708_064841_run_double_contour_polygons_lfountai'
#timestamp='20080714_231759_run_quarter_contour_polygons_lfountai'
#timestamp='20080714_234934_run_eighth_contour_polygons_lfountai'
#timestamp='20080714_235634_run_sixteenth_contour_polygons_lfountai'
#timestamp='20080715_015727_run_1-32_contour_polygons_lfountai'
#timestamp='20080715_023223_run_quadruple_contour_polygons_lfountai'
#timestamp='20080721_015521_run_1-64_contour_polygons_lfountai'
#timestamp='20080725_051221_run_octuple_contour_polygons_lfountai'
timestamp='20080725_022934_run_1.5_contour_polygons_lfountai'


filename=project_truescale.output_dir+timestamp+sep+project_truescale.output_filename

sww2csv_gauges(filename,
                project_truescale.gauges_dir_name,
                quantities = ['stage','speed','depth','elevation'],
                verbose=True)
                

    

