"""Automatic verification that the ANUGA code validates against the example
   devised by Joquim Luis. See README.txt for more details.
"""

import unittest
import os

class Test_Pixel(unittest.TestCase):
    def setUp(self):
        
        # Remove garbage
        for file in os.listdir('.'):

            # Don't remove br_swan.sww            
            if file == 'br_swan.sww': continue
            
            if file.endswith('.stdout') or\
               file.endswith('.dem') or\
               file.endswith('.pts') or\
               file.endswith('.sww') or\
               file.endswith('.msh') or\
               file.endswith('~'):
                os.remove(file)
                
        
    def tearDown(self):
        pass

    def test_that_script_can_run_without_errors(self):

        s = 'run_pixel_registration.py'
        res = os.system('python %s > run_pixel_registration.stdout' %s)
        assert res == 0



#-------------------------------------------------------------
if __name__ == "__main__":
    suite = unittest.makeSuite(Test_Pixel, 'test')
    runner = unittest.TextTestRunner(verbosity=2)
    runner.run(suite)
