"""Validation of the AnuGA implementation of the shallow water wave equation.

This script sets up Okushiri Island benchmark as published at the

THE THIRD INTERNATIONAL WORKSHOP ON LONG-WAVE RUNUP MODELS
June 17-18 2004
Wrigley Marine Science Center
Catalina Island, California
http://www.cee.cornell.edu/longwave/


The validation data was downloaded and made available in this directory
for convenience but the original data is available at
http://www.cee.cornell.edu/longwave/index.cfm?page=benchmark&problem=2
where a detailed description of the problem is also available.


Run create_okushiri.py to process the boundary condition and build a the
mesh before running this script.

"""

# Module imports
from anuga.shallow_water import Domain
from anuga.shallow_water import Reflective_boundary
from anuga.shallow_water import Transmissive_Momentum_Set_Stage_boundary
from anuga.abstract_2d_finite_volumes.util import file_function
from anuga.fit_interpolate.fit import fit_to_mesh_file

import project


#-------------------------
# Create Domain from mesh
#-------------------------

import time
t0 = time.time()

fit_to_mesh_file(project.mesh_filename, project.bathymetry_filename,
                 project.mesh_filename_elevation,
                 alpha=0.02,                    
                 verbose=True)

print 'That took %.2f seconds' %(time.time()-t0)
